package polyglot.ext.ejava.types;

import java.util.Set;

import polyglot.types.ParsedClassType;
import polyglot.types.Type;

public interface ExtensionType extends ParsedClassType {
  public boolean okAsType();
  public ExtensionType okAsType(boolean b);
  public ParsedClassType interfaceType();
  public String extensionName();
  public void extensionName(String extensionName);
  public boolean isTop();
  public void isTop(boolean isTop);

  public Set cases();
  public void addCase(Type t);

  public ExtensionType parent();
  public void parent(ExtensionType et);
  public boolean implicitlyApplicable(Type t);
  public boolean applicableTo(Type t);
}

