package polyglot.ext.ejava.ast;

import java.util.Set;

import polyglot.ast.ClassDecl;
import polyglot.ast.TypeNode;

public interface ExtensionDecl extends ClassDecl {
    TypeNode forClass();
    ExtensionDecl forClass(TypeNode forClass);
    boolean isTop();
    Set cases();
    void addCase(ExtensionDecl ed);
    void clearCases();
    void promoteToLocalTop();
    boolean isLocalTop();
}
